unit Protocol;
// NetSpeakerphone Network protocol v4.11
// v4.11 -      
//
// 4.12  -     
//
//  2007 -  GetAvatar, GetForm


interface


const

  UINgroup=100;             //  900 
  UINmin=1000;              //    UIN
  UINmax=2147483648;        //

  SvcPacketID=$0411;             //   
  SoundPacketID=$0410;           //   

  MultiPacketID=$A500;           // - ( $FFF0)

  SvcPacketIDold=$0402;          //  
  SoundPacketIDold=$0404;        // --//--//--

  {  UpdateServer }
  SvcPacketGetVersion=$8000;
  SvcPacketUpdate=$8001;
  SvcPacketClose=$8002;

  MinPingInterval=2000;          //   

  {     (PacketHeader.PacketType) }
  Packet_Ping=$0001;                  //  
  Packet_Echo=$0002;                  // - -  
  Packet_Status=$0003;                // =status
  Packet_GetAwayMsg=$0006;	          //   
  Packet_AwayMsg=$0007;			          //  
  Packet_Text=$0010;                  //      %..
  Packet_TextOffline=$0013;           //   Offline Messages
  Packet_GetLastTextTimeStamp=$0011;  //  timestamp   
  Packet_LastTextTimeStamp=$0012;     //   
  Packet_Chat=$0014;                  //   
  Packet_GetAvatar=$0015;             // *  
  Packet_GetVCard=$0016;              // *  
  Packet_Avatar=$0017;                // *   
  Packet_VCard=$0018;                 // *    
  Packet_NotifyType=$0020;            //   
  Packet_NotifyTextClose=$0022;       //     
  Packet_SoundCall=$0021;             //  (  )
  Packet_CancelFileAcceptWait=$0024;  //    


  {  }
  PacketTypeMask=$001FF;              //  
  PacketTypeFlag_Protect=$0800;       //  

  { PacketFlags  }
  PacketFlag_FromServer	    =$0001;		//   
  PacketFlag_Broadcast      =$0002;		//  
  PacketFlag_MultiReceptions=$0004;   //       
  PacketFlag_HasCallbackIP  =$0008;   //        (Cardinal) (   )
                                      //    4.4 rc2
  {   () }
  PacketFlag_SrcHasBanText		  =$0010;	  //   
  PacketFlag_SrcHasBanSound		  =$0020;	  //      
  PacketFlag_SrcHasBanFiles		  =$0040;	  //    

  {   .   .    }
  PacketFlag_DstHasBanText		=$0100;   //    
  PacketFlag_DstHasBanSound	  =$0200;	  //    
  PacketFlag_DstHasBanFiles		=$0400;	  //    

  {      ( )}
  PacketText:array [0..76] of String = ('',
  '[$0001=Ping]    ',
  '[$0002=Echo] - -  ',
  '[$0003=Status] ',
  '[$0004]', '[$0005]',
  '[$0006=GetAwayMsg]   ',
  '[$0007=AwayMsg]  ',
  '[$0008]', '[$0009]', '[$000a]', '[$000b]', '[$000c]', '[$000d]', '[$000e]', '[$000f]',
  '[Text=$0010]',
  '[$0011=GetLastTextTimeStamp]  timestamp   ',
  '[$0012=LastTextTimeStamp]   ',
  '[$0013]',
  '[$0014=Chat]',
  '[$0015=GetAvatar]',
  '[$0016=GetVCard]',
  '[$0017=Avatar]',
  '[$0018=VCard]',
  '[$0019]', '[$001a]', '[$001b]', '[$001c]', '[$001d]',   '[$001e]', '[$001f]',
  '[$0020=TypeNotify]   ',
  '[$0021=SoundCall] ',
  '[$0022=NotifyTextClose]   ',
  '[$0023]',
  '[$0024]=CancelAcceptWait', '[$0025]', '[$0026]', '[$0027]', '[$0028]', '[$0029]', '[$002a]', '[$002b]', '[$002c]', '[$002d]', '[$002e]', '[$002f]',
  '[$0030]=ServerOnline', '[$0031]=ServerOffline', '[$0032]=ServerBanUpdate', '[$0033]=Server Admin message',
  '[$0034]=ClientShutdown', '[$0035]=ServerGetConfig', '[$0036]=ServerConfigBegin', '[$0037]=ServerConfigEnd', '[$0038]=ServerConfigLine', '[$0039]=ToServerConfigBegin',
  '[$003a]=ToServerConfigEnd', '[$003b]=ToServerConfigLine', '[$003c]=', '[$003d]=', '[$003e]=', '[$003f]=',
  '[$0040]=ServerOK', '[$0041]=ServerCheckClient', '[$0042]=ServerRequestClientsLocal', '[$0043]=ServerRequestClientsLocal', '[$0044]=ServerPing',
  '[$0045]', '[$0046]', '[$0047]', '[$0048]', '[$0049]', '[$004A]=ServerSetStatus', '[$004B]=ServerClientRealIP',
  '[$004C]=ServerPoliticScriptLine'
  );

  {   (port= BASE+1) }
  sdt_SILENCE=0;      // Data= SilenceLen:word
  sdt_PCM=1;          //  PCM
  sdt_ADPCM=2;        //  ADPCM
  sdt_SPEEX=3;        //  SPEEX
  sdt_WaveOpen=$10;   //  
  sdt_WaveClose=$11;  //*   ( )

  // ....  
  StatusMask=$0F;
  StatusFlag_HasWaveOut=$10;
  StatusFlag_HasWaveIn=$20;
  StatusFlag_PlayingSound=$40;  // not used
  StatusFlag_SendingSound=$80;  // not used
  StatusFlag_Chat=$100;
  StatusFlag_Locked=$200;       //     
                                //    1.23 

  //   -    
  cls_Offline=0;   //  
  cls_Normal=1;    // idle
  cls_Busy=2;      // 
  cls_Away=3;      //    + 
  cls_Invisible=4; //  (  4.5)           

type

  { --------------}
  TMultiPacketHeader=packed record
    PacketType: word;
    PacketsCount: word;
    //      (array of Word)  
  end;  


  { --------   [udp:8760]   PacketID ---------}
  TPacketHeader=packed record
    PacketType: word;      //   ( UDP  )
    PacketFlags: cardinal; //  
    SrcUIN: cardinal;      // UIN - ( TCP  )
    DstUIN: cardinal;      //  =0  Broadcast, =1  old protocol
    UDPPort: word;         //    
    StatusAll: word;       //   
    DataSize: word;        //    
    TimeStamp: integer;    //    (   . . )
  end;

  { --------   [udp:8761]---------}
  TSoundHeader=packed record
    PacketID: word;
    DataType: word;	       //   (sdt_PCM, sdt_ADPCM, sdt_Speex, sdt_Silence)
    HeaderSize: word;	     //   
    SampleRate: word;	     //  
    SrcUIN: cardinal;      // UIN (new)
    DstUIN: cardinal;      // UIN  (new)
    TimeStamp: integer;	   // TimeStamp 
    PacketIndex: integer;  //     ()
    PacketFlags: cardinal; //   * not used = 0
    DataSize: word;	       //    
    //+RawData
  end;

  {   }
  //v4.02 (v4.01 with packet record)
  TPacketHeader402=packed record
                     PacketType:word;      //   ( UDP  )
                     UIN:cardinal;         // UIN - ( TCP  )
                     StatusAll:word;       //   
                     DataSize:word;        //    
                     TimeStamp:integer;    //    (   . . )
                   end;
  //  
  TSoundHeader403=packed record
     PacketID:word;
     DataType:word;	      //   (sdt_PCM, sdt_ADPCM, sdt_Speex, sdt_Silence)
     HeaderSize:word;	    //    (+2!!)
     SampleRate:word;	    //  
     UIN:cardinal;        // UIN
     TimeStamp:integer;	  // TimeStamp 
     PacketIndex:integer; //     ()
     DataSize:integer;	  //    
     //+RawData
  end;

implementation

end.
